##this function runs every tick

effect clear @a wither
#executes as every hit entity
execute at @a as @e[distance=..8,type=!player] at @s run function cbt:preentityhit
execute as @e[predicate=cbt:tntonhead] at @s run function cbt:preentityhit

#executes as rangeswitchers
execute as @e[tag=3,type=skeleton] at @s run function cbt:rangeswitcher/rangeswitcher
execute as @e[tag=11,type=skeleton] at @s run function cbt:rangeswitcher/rangeswitcher11
execute as @e[tag=bossd4rangeswitch,type=wither_skeleton] at @s run function cbt:rangeswitcher/rangeswitcherbossd4

#killing things that dont need to exist. 
kill @e[type=experience_orb]

##Runs particles
execute at @a as @e[distance=..30] at @s run function cbt:bleedparticles
execute as @a if score @s usedmelee matches 1 run execute at @s anchored eyes run particle minecraft:sweep_attack ^ ^ ^1.2 0.01 0.01 0.01 1 2 force

##Code for movement mechanics
#Updated as of 30.01.22 to use attributes instead of potion effects
#Unsure if this is better or not, but it allows for finetuning
#The number after spritnstlowdown dictates how much the player should be slowed down. To have sprint be 10% faster than walk this number is -0.2
#Update 05.02.22 changed the sprint speed to be 12% more than walk
##Extra info on movement speed:
#Max sprint speed with current impolementation of 12% increase to 0.12350 is 0.13832
#Vanilla walking speed is 0.10000. Vanilla sprinting speed is 30 faster tahn that: 0.13000
#This means that the current sprint speed is 6.4% faster than vanilla sprint.
#Current walk speed is 23.5% faster than vanilla walk

execute as @a[predicate=cbt:movement/issprinting] run attribute @s generic.movement_speed modifier add ff179a04-baab-42ca-9f5a-0d3c7fa77941 "sprintslowdown" -0.18 multiply_base
execute as @a[predicate=!cbt:movement/issprinting] run attribute @s generic.movement_speed modifier remove ff179a04-baab-42ca-9f5a-0d3c7fa77941



##Code for reloading after player rejoins
execute as @a[scores={leftgame=1..}] at @s run attribute @s generic.movement_speed base set 0.1235
scoreboard players set @a[scores={leftgame=1..}] leftgame 0

#executes as players that just got a kill
execute as @a if score @s playergotkill matches 1.. at @s run function cbt:playergotkill


##Resets slottime for players that hit entities with wa weapon
execute as @a if score @s usedmelee matches 1 run function cbt:playerusedweapon/melee
execute as @a if score @s useddagger matches 1 run function cbt:playerusedweapon/dagger
execute as @a if score @s usedhammer matches 1 run function cbt:playerusedweapon/hammer
execute as @a if score @s usedaxe matches 1 run function cbt:playerusedweapon/axe

##Resets all scoreboards that are bools that update every tick. This must be at the bottom of the function
scoreboard players set @a playergotkill 0

scoreboard players set @a usedmelee 0
scoreboard players set @a useddagger 0
scoreboard players set @a usedhammer 0
scoreboard players set @a usedaxe 0

execute as @a if score @s Health matches ..6 run effect give @s resistance 999999 1 true
execute as @a if score @s Health matches 6.. run effect clear @s resistance

##This is code that is not yet used, because it is for features that arent yet used, and is thus commented out
#for hostiles with healing abilities, not yet implemented
#execute as @e[tag=healer] run execute store result score @s Health run data get entity @s Health
#execute as @e[tag=healer] if score @s Health matches 0..10 at @s run function cbt:effects/regeneration

#for camo armor not yet implemented feature
#execute as @a[predicate=cbt:cloaked] run effect give @s invisibility 1 1 true

#scoreboards for slottime
scoreboard players add @a slottime 1
execute as @a run execute store result score @s selectedslot run data get entity @s SelectedItemSlot 1
execute as @a unless score @s previousselectedslot = @s selectedslot run scoreboard players set @s slottime 0
execute as @a run scoreboard players operation @s previousselectedslot = @s selectedslot

#added on 19.02.22. Might be performance heavy
execute at @a[gamemode=adventure] as @e[distance=..10,team=hostile] run function cbt:atadventureplayer
